package com.joyful.euphoria.board.xmlactivity;

import static com.bumptech.glide.request.RequestOptions.bitmapTransform;

import android.graphics.Rect;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewTreeObserver;
import android.view.WindowManager;

import androidx.activity.EdgeToEdge;
import androidx.activity.OnBackPressedCallback;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.ad.tradpluslibrary.TPAdManager;
import com.joyful.euphoria.board.R;
import com.joyful.euphoria.board.databinding.ActivityPreviewXmlBinding;
import com.joyful.euphoria.board.utils.KeyNamesUtils;
import com.joyful.euphoria.board.utils.Normal;
import com.joyful.euphoria.board.utils.SaveCurrentThemeUtils;
import com.bumptech.glide.Glide;
import com.bumptech.glide.load.DataSource;
import com.bumptech.glide.load.engine.GlideException;
import com.bumptech.glide.request.RequestListener;
import com.bumptech.glide.request.target.Target;

import jp.wasabeef.glide.transformations.BlurTransformation;
import kotlin.Unit;
import kotlin.jvm.functions.Function0;


public class PreviewXML extends AppCompatActivity {
    private ActivityPreviewXmlBinding vb;
    public static String key_name = "key_name";
    private int mPreviousKeyboardHeight = -1;


    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        vb = ActivityPreviewXmlBinding.inflate(getLayoutInflater());
        EdgeToEdge.enable(this);
        setContentView(vb.getRoot());
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });
        TPAdManager.INSTANCE.loadAllAd(this);
        onInit();

        getOnBackPressedDispatcher().addCallback(
                this, new OnBackPressedCallback(true) {
                    @Override
                    public void handleOnBackPressed() {
                        back();
                    }
                });
    }

    private void back() {
        TPAdManager.INSTANCE.showTPAD(PreviewXML.this, new Function0<Unit>() {
            @Override
            public Unit invoke() {
                finish();
                return null;
            }
        });
    }

    public void onInit() {

        String stringExtra = getIntent().getStringExtra(key_name);
        vb.title.setText(stringExtra);

        String curPath = SaveCurrentThemeUtils.INSTANCE.getSkinPath();

        vb.idBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                back();
            }
        });
        if (curPath == null) {
            return;
        }

        String bgPath = curPath + "res/drawable-xxhdpi-v4/" + KeyNamesUtils.previewBg;

        Drawable bgDraw = Normal.INSTANCE.getBgDrawable(this, bgPath);
        if (bgDraw != null) {

            Glide.with(this)
                    .load(bgDraw)
                    .apply(bitmapTransform(new BlurTransformation(15, 3))) // 设置模糊半径和模糊采样
                    .listener(new RequestListener<Drawable>() {
                        @Override
                        public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
                            return false;
                        }

                        @Override
                        public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
                            vb.main.setBackground(resource);

                            return false;
                        }
                    })
                    .preload();

        }
        keyboardheight();
        vb.et.requestFocus();
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_VISIBLE);

    }


    private void keyboardheight() {
        final View rootView = getWindow().getDecorView();
        rootView.getViewTreeObserver().addOnGlobalLayoutListener(new ViewTreeObserver.OnGlobalLayoutListener() {


            @Override
            public void onGlobalLayout() {
                Rect r = new Rect();
                rootView.getWindowVisibleDisplayFrame(r);
                int screenHeight = rootView.getRootView().getHeight();
                int keypadHeight = screenHeight - r.bottom;

                if (keypadHeight != mPreviousKeyboardHeight) {
                    if (mPreviousKeyboardHeight < keypadHeight) {
                        mPreviousKeyboardHeight = keypadHeight;
                        ViewGroup.MarginLayoutParams params = (ViewGroup.MarginLayoutParams) vb.et.getLayoutParams();
                        params.bottomMargin = mPreviousKeyboardHeight;
                        vb.et.setLayoutParams(params);
                    }

                }
            }
        });
    }
}